Package io.vertx.core.http

## Interface Cookie

-     public interface Cookie

  Represents an HTTP Cookie.

  All cookies must have a name and a value and can optionally have other fields set such as path, domain, etc.

- - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static Cookie` | `cookie​(String name, String value)` | Create a new cookie
    `String` | `encode()` | Encode the cookie to a string.
    `String` | `getDomain()` |
    `long` | `getMaxAge()` |
    `String` | `getName()` |
    `String` | `getPath()` |
    `CookieSameSite` | `getSameSite()` |
    `String` | `getValue()` |
    `boolean` | `isHttpOnly()` |
    `boolean` | `isSecure()` |
    `Cookie` | `setDomain​(String domain)` | Sets the domain of this cookie
    `Cookie` | `setHttpOnly​(boolean httpOnly)` | Determines if this cookie is HTTP only.
    `Cookie` | `setMaxAge​(long maxAge)` | Sets the maximum age of this cookie in seconds.
    `Cookie` | `setPath​(String path)` | Sets the path of this cookie.
    `Cookie` | `setSameSite​(CookieSameSite policy)` | Sets the same site of this cookie.
    `Cookie` | `setSecure​(boolean secure)` | Sets the security getStatus of this cookie
    `Cookie` | `setValue​(String value)` | Sets the value of this cookie

- - ### Method Detail

    - #### cookie

          static Cookie cookie​(String name,
                               String value)

      Create a new cookie
      Parameters:
        `name` - the name of the cookie
        `value` - the cookie value
      Returns:
        the cookie

    - #### getName

          String getName()

      Returns:
        the name of this cookie

    - #### getValue

          String getValue()

      Returns:
        the value of this cookie

    - #### setValue

          Cookie setValue​(String value)

      Sets the value of this cookie
      Parameters:
        `value` - The value to set
      Returns:
        a reference to this, so the API can be used fluently

    - #### setDomain

          Cookie setDomain​(String domain)

      Sets the domain of this cookie
      Parameters:
        `domain` - The domain to use
      Returns:
        a reference to this, so the API can be used fluently

    - #### getDomain

          String getDomain()

      Returns:
        the domain for the cookie

    - #### setPath

          Cookie setPath​(String path)

      Sets the path of this cookie.
      Parameters:
        `path` - The path to use for this cookie
      Returns:
        a reference to this, so the API can be used fluently

    - #### getPath

          String getPath()

      Returns:
        the path for this cookie

    - #### setMaxAge

          Cookie setMaxAge​(long maxAge)

      Sets the maximum age of this cookie in seconds. If an age of `0` is specified, this cookie will be automatically removed by browser because it will expire immediately. If `Long.MIN_VALUE` is specified, this cookie will be removed when the browser is closed. If you don't set this the cookie will be a session cookie and be removed when the browser is closed.
      Parameters:
        `maxAge` - The maximum age of this cookie in seconds

    - #### getMaxAge

          long getMaxAge()

      Returns:
        the maxAge of this cookie

    - #### setSecure

          Cookie setSecure​(boolean secure)

      Sets the security getStatus of this cookie
      Parameters:
        `secure` - True if this cookie is to be secure, otherwise false
      Returns:
        a reference to this, so the API can be used fluently

    - #### isSecure

          boolean isSecure()

      Returns:
        the security status of this cookie

    - #### setHttpOnly

          Cookie setHttpOnly​(boolean httpOnly)

      Determines if this cookie is HTTP only. If set to true, this cookie cannot be accessed by a client side script. However, this works only if the browser supports it. For for information, please look here.
      Parameters:
        `httpOnly` - True if the cookie is HTTP only, otherwise false.

    - #### isHttpOnly

          boolean isHttpOnly()

      Returns:
        the http only status of this cookie

    - #### setSameSite

          Cookie setSameSite​(CookieSameSite policy)

      Sets the same site of this cookie.
      Parameters:
        `policy` - The policy should be one of `CookieSameSite`.
      Returns:
        a reference to this, so the API can be used fluently

    - #### getSameSite

          CookieSameSite getSameSite()

      Returns:
        the SameSite policy of this cookie

    - #### encode

          String encode()

      Encode the cookie to a string. This is what is used in the Set-Cookie header
      Returns:
        the encoded cookie